<?php
abstract class Anc_Library_Plugin_PluginAbstract
{
    protected $_app;
    
    /**
    * Custom feedback to display to the user
    * 
    * @var string|null
    */
    protected $_message;
    
    public final function __construct(Anc_Application $app, $options = null)
    {
        $this->_app = $app;
        $this->init(); 
    }
    
    public function release()
    {
        $this->_app = NULL;
    }
    
    public function init()
    {
    }  
    
    public function setOptions(array $options)
    {
        foreach ($options as $name=>$value) {
            $method = 'set' . ucfirst($name);
            $this->$method($value);
        }   
    }
    
    protected function _throwError($message)
    {
        Anc_Application::autoload('Anc_Library_Plugin_Exception');
        throw new Anc_Library_Plugin_Exception($message);
    }
}
