<?php
require_once CBC_WPMODULE_PATH . '/controllers/Abstract/Ajax.php';

class Cbc_WpModule_Controller_ProgressAjaxController
    extends Cbc_WpModule_Controller_Abstract_Ajax
{
    /**
    * @var Cbc_WpModule_Model_CoreApp
    */
    protected $_model;

    public function init()
    {
        parent::init();

        $this->_model = Cbc_WpModule_Application::getModel('CoreApp');
    }

    public function indexAction()
    {
        if (isset($_POST['session_id'])) {
            session_id($_POST['session_id']);
        }

        @session_start();

        $output = $this->_model->getOutput();
        $result = array();

        $log = isset($output['log'])? $output['log'] : '';
        $from = isset($_POST['from'])? $_POST['from'] : 0;
        $result['log'] = $this->_formatLog(substr($log, $from));
        $result['from'] = strlen($log);

        $status = @$output['status'];
        switch ($status) {
            case 'progress':
                if (isset($output['progress'])) {
                    $this->_view->progress = floor($output['progress']*100);
                }
                break;
            case 'error': //no break
            case 'success':
                $this->_view->message = $output['message'];
                $result['terminate'] = true;
                $this->_model->clearOutput();
                break;
            default:
                $status = NULL;
                //$result['log'] = ("SESSION: " . session_id() . "\n");
        }

        if ($status) {
            $result['statusHtml'] = $this->_view->render("progress/status/{$status}.phtml");
        }

        header('Content-Type: application/json', TRUE);
        echo json_encode($result);
    }

    public function startAction()
    {
        ini_set('error_reporting', E_ALL);
        ini_set('html_errors', 0);
        ini_set('display_errors', 1);

        if (isset($_POST['session_id'])) {
            session_id($_POST['session_id']);
        }

        @session_start();

        if (!isset($_POST['options'])) {
            throw new Exception('No options found');
        }

        $options = unserialize(stripslashes($_POST['options']));
        if (!$options) {
            throw new Exception('Invalid options');
        }

        header('Content-Type: text/plain', TRUE);

        /**
        * @var Cbc_WpModule_Model_CoreApp
        */
        $core = Cbc_WpModule_Application::getModel('CoreApp');
        $core->setup($options);
        $core->generate();
    }

    protected function _formatLog($text)
    {
        $result = $this->_view->escape($text);
        $result = str_replace("\n", "<br />\n", $text);

        return $result;
    }
}