<?php
class Cbc_WpModule_Model_Cron
{
    public function pingThumbs()
    {
        add_filter('posts_where', array($this, 'filterPostsWhere'), 10, 5);
        $upcomingPosts = get_posts(array(
            'post_type'       => 'post',
            'post_status'     => 'future',
            'posts_per_page'  => -1,
            'meta_key'        => Cbc_WpPlugin::PREFIX . '_merchant_id',
        ));
        remove_filter('posts_where', array($this, 'filterPostsWhere'));
        if (!$upcomingPosts) {
            $upcomingPosts = array();
        }

        $existingPosts = get_posts(array(
            'post_type'       => 'post',
            'post_status'     => 'publish',
            'posts_per_page'  => -1,
            'meta_key'        => Cbc_WpPlugin::PREFIX . '_merchant_id',
        ));
        if (!$existingPosts) {
            $existingPosts = array();
        }

        $posts = array_merge($upcomingPosts, $existingPosts);

        $thumbSize = Cbc_WpModule_Application::getModel('Template')->getOption('tsize');
        if ($posts) {
            require_once 'Pumka/Thumbs/PagePeeker.php';
            $thumb = new Pumka_Thumbs_PagePeeker;
            foreach ($posts as $post) {
                $url = Cbc_WpModule_Application::getModel('PostMeta')
                    ->setPostId($post->ID)
                    ->getValue('merchant_url');

                $thumb->setOptions(array(
                    'size'  => $thumbSize,
                    'url'   => $url,
                ));

                if (!$thumb->isImageReady()) {
                    $thumb->downloadImage();
                }
            }
        }
    }

    public function filterPostsWhere($where = '')
    {
        $where .= " AND post_date <= '" . date('Y-m-d', strtotime('+5 days')) . "'";
        return $where;
    }
}