<?php
class Cbc_WpModule_Model_Linker
{
    public function redirect($slug)
    {
        if (headers_sent($file, $line)) {
            exit("Error: Headers already sent. Output started at {$file}:{$line}");
        }

        $res = get_posts(array(
            'name' => $slug,
            'post_status' => 'any',
        ));

        if (!$res) {
            return;
        }

        $post = array_shift($res);

        $options = Cbc_WpModule_Application::getModel('Options');
        $meta = Cbc_WpModule_Application::getModel('PostMeta')
            ->setPostId($post->ID);

        $merchantId = $meta->getValue('merchant_id');

        if (!$merchantId) {
            return;
        }

        $affiliateId = $options->getOption('clickbank_id');
        $trackingId = urlencode($options->getOption('tracking_id'));

        $url = "http://{$affiliateId}.{$merchantId}.hop.clickbank.net";
        if ('' != $trackingId) {
            $url .= "/?tid={$trackingId}";
        }

        header('Location: ' . $url, TRUE, 302);
        $encodedUrl = htmlspecialchars($url, ENT_QUOTES, 'utf-8');
echo
"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">
<html>
<head>
    <script type=\"text/javascript\">
    /* <![CDATA[ */
        window.location=\"{$url}\";
    /* ]]> */
    </script>
    <title>Redirect</title>
    <meta http-equiv=\"REFRESH\" content=\"0;url={$encodedUrl}\">
    <meta name=\"ROBOTS\" content=\"NOINDEX, NOFOLLOW\">
</head>
<body>
    Redirected to {$encodedUrl}.<br />
    <a href=\"{$encodedUrl}\">Click here</a> if your browser doesn't support redirection.
</body>
</html>";
        exit();
    }
}